<?php

/**

 * @version     1.0.0

 * @package     com_geommunity3cb

 * @copyright   Copyright (C) 2016. Adrien ROUSSEL Nordmograph.com All rights reserved.

 * @license     GNU General Public License version 3 or later; see LICENSE.txt

 * @author      Nordmograph <contact@nordmograph.com> - https://www.nordmograph.com./extensions

 */



// No direct access

defined('_JEXEC') or die;



/**

 * @param	array	A named array

 * @return	array

 */

function Geommunity3cbBuildRoute(&$query)

{

	$segments = array();

    

	if (isset($query['task'])) {

		$segments[] = implode('/',explode('.',$query['task']));

		unset($query['task']);

	}

	if (isset($query['id'])) {

		$segments[] = $query['id'];

		unset($query['id']);

	}



	return $segments;

}



/**

 * @param	array	A named array

 * @param	array

 *

 * Formats:

 *

 * index.php?/geommunity3cb/task/id/Itemid

 *

 * index.php?/geommunity3cb/id/Itemid

 */

function Geommunity3cbParseRoute($segments)

{

	$vars = array();

    

	// view is always the first element of the array

	$count = count($segments);

    

    if ($count)

	{

		$count--;

		$segment = array_pop($segments) ;

		if (is_numeric($segment)) {

			$vars['id'] = $segment;

		}

        else{

            $count--;

            $vars['task'] = array_pop($segments) . '.' . $segment;

        }

	}



	if ($count)

	{   

        $vars['task'] = implode('.',$segments);

	}

	return $vars;

}

